

GetScreenPos:	;BH,BL = X,Y	Returns ES:DI=Destination
	push bx
	push ax
		xor ax,ax
		mov al,bh
		mov di,ax
		xor ax,ax
		mov al,bl
		mov bx,40
		mul bx
		add di,ax
		mov ax,0A000h 
		mov es,ax
	pop ax
	pop bx
	ret
	

GetScreenNextLine:
	push ax
		mov ax,di
		add ax,40	
		mov di,ax
	pop ax
	ret

ScreenInit:
	mov     ah, 0           ; int 10,0
    mov     al, 0Dh           ; mode 13 (ega 320x200 16 color)
    int     10h             ; bios int
	ret
  ; Layout: 4-plane planar.  Each pixel color is determined by the combined
          ; value of bits in the four color planes.  Each color plane begins
          ; at a000:0.  To select a plane, use:

            ; OUT 3ceH, 0005H         ;set up for plane masking
            ; OUT 3c4H, n             ;n is: 0102H=plane 0; 0202H=plane 1
                                    ; ;      0402H=plane 2; 0802H=plane 3
            ; ...(write video data)...
            ; OUT 3c4H, 0f02H         ;restore normal plane mask


PrintChar:
	push di
	push si
	push es
	push dx
	push cx
	push bx
	push ax
	push ds
		push ax
			

			mov ax,0f02h		;Default plane mask
			mov dx,03c4h		
			out dx,ax
				
				
				
		;	call domonitor
			
			mov ax,0
			mov al,[ds:CursorY]
			mov bx,40*8
			mul bx
			mov di,ax
			
			mov ax,0
			mov al,[ds:CursorX]
			;rcl ax,1
	;		rcl ax,1
	;		rcl ax,1
			add di,ax

			mov si,offset BitmapFont
			
			mov ax, seg BitmapFont
			mov ds, ax
		pop ax
		sub al,32
		mov ah,0

		mov cl,3
		rcl ax,cl
		
		add si,ax
		
		
		mov cx,8
		push es
			
			mov ax,0A000h 
			mov es,ax
	FontAgain:	
			Call DoPair
			add di,40
		
			dec cx
			jnz FontAgain
		pop es
		
	pop ds
	inc [ds:CursorX]
	cmp [ds:CursorX],40
	jne PrintCharNoNewLine
	call NewLine
PrintCharNoNewLine:
	pop ax
	pop bx
	pop cx
	pop dx
	pop es
	pop si
	ret

	
DoPair:
	mov al,[ds:si]
	mov es:[di],al
	inc si
	;dec di
	ret	

Locate:
		mov [ds:CursorX],bh
		mov [ds:CursorY],bl
	ret
NewLine:
		mov [ds:CursorX],0
		inc [ds:CursorY]
	ret
	
PrintSpace:
	push ax
		mov al,' '
		call PrintChar
	pop ax
	ret
	
SetPalette:
	push si
	push dx
	push cx
	push bx
	push ax
		push ax
			;call domonitor
			mov al,dl		;B
			call PaletteFilterRange
			mov cl,al
			push cx
				mov al,dh		;G
				call PaletteFilterRange
				mov bl,al
				
				mov al,dl		;R
				call PaletteFilterRangeB
				mov bh,al
				
				;mov dx,bx
				
				mov al,bl	;G
				cbw
				mov bl,9	;G*9
				mul bl
				mov si,ax
				
				mov al,bh	;R
				cbw
				mov dl,3	;R*3
				mul dl
				add si,ax
			pop cx
			xor ch,ch	;b
			add si,cx
			
		;mov ax,bx
		;mov bx,offset PaletteLUT
		;xlat					;Get AL from DS:BX+AL
		
		;mov si,ax
		
		
		pop bx
		mov bh,Byte PTR [PaletteLUT+ds:si]
		
		
		mov     ax, 1000h       ;Function 10 - subfunction 0
		;mov     bh, 56         ;NewVal
		;mov     bl, 0          ;Color
		int     10h             ;bios int
	pop ax
	pop bx
	pop cx
	pop dx
	pop si
	pop di
	ret

PaletteFilterRangeB:
		mov cl,4
		shr al,cl
PaletteFilterRange:
		and al,00001111b
		cmp al,0Ah
		jnc PaletteFilter2
		cmp al,05h
		jnc PaletteFilter1
		mov al,0
		ret
PaletteFilter1:
		mov al,1
		ret
PaletteFilter2:
		mov al,2
		ret
PaletteLUT:
	db 0,1,57
	db 4,5,5
	db 60,60,61

	db 2,3,57
	db 20,7,57
	db 20,61,61

	db 58,58,59
	db 58,58,59
	db 62,62,63
